--- old/usr/src/cmd/sgs/gprof/common/printgprof.c	Tue Jun  5 20:44:48 2018
+++ new/usr/src/cmd/sgs/gprof/common/printgprof.c	Tue Jun  5 20:44:48 2018
@@ -22,10 +22,10 @@
 /*
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2018 Jason King
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <ctype.h>
 #include <string.h>
 #include <sys/param.h>
@@ -500,10 +500,7 @@
 	c = demangled_name(selfp);
 
 	if (selfp->name != 0) {
-		if (!Cflag)
-			(void) printf("%s", selfp->name);
-		else
-			(void) printf("%s", c);
+		(void) printf("%s", c);
 
 #ifdef DEBUG
 		if (debug & DFNDEBUG)
@@ -523,24 +520,26 @@
 		else
 			(void) printf(" (%d)", selfp->index);
 	}
+
+	if (c != selfp->name)
+		free((void *)c);
 }
 
 void
 print_demangled_name(int n, nltype *selfp)
 {
-	char *c;
+	char *c = (char *)demangled_name(selfp);
 	int i;
 
-	c = selfp->name;
-
-	if (strcmp(c, demangled_name(selfp)) == 0)
+	if (c == selfp->name)
 		return;
-	else {
-		(void) printf("\n");
-		for (i = 1; i < n; i++)
-			(void) printf(" ");
-		(void) printf("[%s]", selfp->name);
-	}
+
+	(void) printf("\n");
+	for (i = 1; i < n; i++)
+		(void) printf(" ");
+	(void) printf("[%s]", selfp->name);
+
+	free(c);
 }
 
 void
@@ -882,11 +881,11 @@
 void
 striped_name(char *s, nltype **npp)
 {
-	const char *d;
+	const char *name, *d;
 	char *c;
 
 	c = (char *)s;
-	d = demangled_name(*npp);
+	name = d = demangled_name(*npp);
 
 	while ((*d != '(') && (*d != '\0')) {
 		if (*d != ':')
@@ -895,6 +894,9 @@
 			d++;
 	}
 	*c = '\0';
+
+	if ((*npp)->name != name)
+		free((void *)name);
 }
 
 /*
@@ -1038,13 +1040,16 @@
 				if (does_clash(namesortnlp, i, nnames)) {
 					(void) printf("%6.6s %d:%s\n",
 					    peterbuffer, nlp->module->id, d);
-				} else
+				} else {
 					(void) printf("%6.6s %s\n", peterbuffer,
 					    d);
+				}
 
-				if (d != nlp->name)
+				if (d != nlp->name) {
 					(void) printf("%6.6s   [%s]", "",
 					    nlp->name);
+					free((void *)d);
+				}
 			} else {
 				(void) printf("%6.6s ", peterbuffer);
 				(void) sprintf(peterbuffer, "<cycle %d>",
